﻿using Infragistics.Controls.Grids;
using Infragistics.Olap.Data;
using Infragistics.Olap.FlatData;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Windows.Threading;

namespace XamPivotGridExpansionModifierCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        DispatcherTimer timer;
        public MainWindow()
        {
            InitializeComponent();
            timer = new DispatcherTimer();
            timer.Interval = new TimeSpan(0, 0, 0, 1);
            timer.Tick += Timer_Tick;
        }        
                
        private void XamPivotGrid_AxisExpansionChanging(object sender, Infragistics.Controls.Grids.PivotCancellableAxisEventArgs e)
        {
            if(Keyboard.IsKeyDown(Key.LeftCtrl) || Keyboard.IsKeyDown(Key.RightCtrl))
            {
                FlatDataSource fds = pivotGrid.DataSource as FlatDataSource;

                if(e.HeaderCell != null)
                {                   
                    pivotGrid.AxisExpansionChanging -= XamPivotGrid_AxisExpansionChanging;

                    List<PivotHeaderCell> headerCellList = new List<PivotHeaderCell>() { e.HeaderCell };

                    Dispatcher.BeginInvoke(new Action(() =>
                    {
                        ExpandAllHeaderCells(headerCellList, pivotGrid.GridLayout.RowHeaderCells);
                    }));
                }                
                else
                {
                    return;
                }
            }            
        }

        #region Commented As FlatFilterMember Expansion is Not Correct...
        //private PivotHeaderCell GetUltimateParentHeaderCell(PivotHeaderCell cell)
        //{
        //    if(cell.ParentCell != null)
        //    {
        //        return GetUltimateParentHeaderCell(cell.ParentCell);
        //    }
        //    else
        //    {
        //        return cell;
        //    }
        //}

        //private FlatFilterMember GetUltimateParentMember(string caption, FlatDataSource data, bool isRow, bool isColumn)
        //{
        //    FlatFilterMember returnMember = null;
        //    if (isRow)
        //    {
        //        foreach(FlatDataFilterViewModel fdfvm in data.Rows)
        //        {
        //            foreach(FlatFilterMember member in fdfvm.FilterMembers)
        //            {
        //                if (member.Caption.Equals(caption))
        //                {
        //                    returnMember = member;
        //                    break;
        //                }
        //            }

        //            if(returnMember != null)
        //            {
        //                break;
        //            }
        //        }
        //    }
        //    else if (isColumn)
        //    {
        //        foreach (FlatDataFilterViewModel fdfvm in data.Columns)
        //        {
        //            foreach (FlatFilterMember member in fdfvm.FilterMembers)
        //            {
        //                if (member.Caption.Equals(caption))
        //                {
        //                    returnMember = member;
        //                    break;
        //                }
        //            }

        //            if (returnMember != null)
        //            {
        //                break;
        //            }
        //        }
        //    }

        //    return returnMember;

        //}

        //private FlatFilterMember GetExpansionFilterMember(string caption, FlatFilterMember member)
        //{
        //    FlatFilterMember filterMember = null;

        //    foreach(FlatFilterMember loopedMember in member.FilterMembers)
        //    {
        //        if (loopedMember.Caption.Equals(caption))
        //        {
        //            filterMember = loopedMember;                   
        //            break;
        //        }
        //        else if(filterMember != null)
        //        {
        //            break;
        //        }
        //        else
        //        {
        //            filterMember = GetExpansionFilterMember(caption, loopedMember);
        //        }
        //    }

        //    return filterMember;       
        //}

        //private void ExpandAllMembers(FlatFilterMember member, FlatDataSource data)
        //{
        //    foreach (FlatFilterMember filterMember in member.FilterMembers)
        //    {
        //        filterMember.IsExpanded = true;


        //        //if (filterMember.HasChildren)
        //        //{
        //        //    ExpandAllMembers(filterMember);
        //        //}            
        //    }
        //}

        #endregion
                    
        List<PivotHeaderCell> newList;                
        private void ExpandAllHeaderCells(List<PivotHeaderCell> parentHeaders, Collection<PivotHeaderCell> headerCollection)
        {            
            newList = new List<PivotHeaderCell>();

            foreach(PivotHeaderCell cell in headerCollection)
            {
                if(cell.ParentCell != null)
                {
                    string caption = cell.ParentCell.Member.Caption;
                    if (parentHeaders.Where(p => p.Member == cell.ParentCell.Member).Count() != 0)
                    {
                        cell.IsExpanded = true;
                        newList.Add(cell);
                    }
                }
            }

            timer.Start();                
        }


        private void Timer_Tick(object sender, EventArgs e)
        {
            if (newList.Count != 0)
            {
                ExpandAllHeaderCells(newList, pivotGrid.GridLayout.RowHeaderCells);
            }
            else
            {
                timer.Stop();
                pivotGrid.AxisExpansionChanging += XamPivotGrid_AxisExpansionChanging;
            }
        }   
    }
}
